/* SPDX-License-Identifier: GPL-2.0 */
#ifndef __AVM_ENH_CMDLINE_MTD_H__
#define __AVM_ENH_CMDLINE_MTD_H__

#define MAX_AVM_FILESYSTEMS 10
#define MAX_AVM_ADDITIONAL_MTDS 1
#define MAX_AVM_MTD_NAME_LENGTH 64
#define AVM_DEFAULT_MTD_NAME "update-image"
#define NUM_AVM_MTDRAMS (MAX_AVM_FILESYSTEMS + MAX_AVM_ADDITIONAL_MTDS)

#define AVM_MAX_CMDLINE_MTD_EXT 1024

enum avm_mtd_group_selector {
	GROUP_MTDS,
	GROUP_FILESYSTEMS,
};


/*
 * set mtd resource info
 */
extern int avm_mtd_set_mtdram_info(char *name,
				enum avm_mtd_group_selector group_selector,
				resource_size_t start,
				resource_size_t end, unsigned int flags);

/*
 * remove and reserve mtd memory according to the early param parsing
 * during bootmem initialization
 */
extern void avm_mtd_remove_and_reserve_mem_area(void);


#endif
